Subject: Re: [PATCH 2/3] powerpc: Make default kexec/crash_kernel ops implicit

From: Michael Ellerman <[email-masked]>
Date: Tue, 23 Dec 2008 11:15:21 +1100

On Mon, 2008-12-22 at 03:11 +0300, Anton Vorontsov wrote:
> On Mon, Dec 22, 2008 at 10:08:42AM +1100, Michael Ellerman wrote:
> > On Tue, 2008-12-16 at 19:23 +0300, Anton Vorontsov wrote:
> > > This patch removes need for each platform to specify default kexec and
> > > crash kernel ops, thus effectively adds a working kexec support for most
> > > boards.
> > > 
> > > Platforms that can't cope with default ops will explode in some weird
> > > way (a hang or reboot is most likely), which means that the board's
> > > kexec support should be fixed or blacklisted via dummy _prepare callback
> > > returning -ENOSYS.
> > 
> > But where is the patch to do this?
> 
> The -ENOSYS dummy callback is a last resort thing to do when nobody
> cares or it's impossible to fix the Kexec on some board. We don't
> have any such boards (yet).

Yes we do, iseries, so at the very least we need a patch for that.

> > The chance of kexec working on some random machine that's never been
> > tested is pretty slim, every driver needs to be aware its hardware might
> > be in a weird state,
> 
> The boards setup isn't always static. The Kexec might work perfectly
> well on a standalone board, but might hang with some weird PCI device
> attached to it (think that it might need some PCI fixup on shutdown).
> 
> I think that a "Kexec tested to work on a particular board" term
> just doesn't exist. It might work, but it might hang with other setup
> on the *same* board.

Sure, nothing is 100%, I'd just rather that someone has at least tried a
kexec on the basic config and had it work.

> But in practice the Kexec work on every 6xx board I have. And I have
> pretty much of Freescale boards (almost all from the 83xx series),
> and I don't think it's practical to add #ifdef CONFIG_KEXEC into the
> every board file...

OK in that case I'm OK with it. The Kconfig restricts it to only PPC64
or 6xx, so it's not enabled on _every_ platform.

cheers

-- 
Michael Ellerman
OzLabs, IBM Australia Development Lab

wwweb: http://michael.ellerman.id.au
phone: +61 2 6212 1183 (tie line 70 21183)

We do not inherit the earth from our ancestors,
we borrow it from our children. - S.M.A.R.T Person